Package net.sf.saxon.expr.sort

## Class UntypedNumericComparer

- java.lang.Object
- - net.sf.saxon.expr.sort.UntypedNumericComparer

- All Implemented Interfaces:
    `AtomicComparer`

      public class UntypedNumericComparer
      extends java.lang.Object
      implements AtomicComparer

  A specialist comparer that implements the rules for comparing an untypedAtomic value (always the first operand) to a numeric value (always the second operand)

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `UntypedNumericComparer()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareAtomicValues​(AtomicValue a, AtomicValue b)` | Compare two AtomicValue objects according to the rules for their data type.
    `boolean` | `comparesEqual​(AtomicValue a, AtomicValue b)` | Compare two AtomicValue objects for equality according to the rules for their data type.
    `StringCollator` | `getCollator()` | Get the collation used by this AtomicComparer if any
    `AtomicComparer` | `provideContext​(XPathContext context)` | Supply the dynamic context in case this is needed for the comparison
    `static boolean` | `quickCompare​(UntypedAtomicValue a0, NumericValue a1, int operator, ConversionRules rules)` | Optimized routine to compare an untyped atomic value with a numeric value.
    `java.lang.String` | `save()` | Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UntypedNumericComparer

          public UntypedNumericComparer()

  - ### Method Detail

    - #### quickCompare

          public static boolean quickCompare​(UntypedAtomicValue a0,
                                             NumericValue a1,
                                             int operator,
                                             ConversionRules rules)
                                      throws XPathException

      Optimized routine to compare an untyped atomic value with a numeric value. This attempts to deliver a quick answer if the comparison is obviously false, without performing the full string-to-double conversion
      Parameters:
        `a0` - the untypedAtomic comparand
        `a1` - the numeric comparand
        `operator` - the comparison operator: a singleton operator such as Token.FEQ
        `rules` - the conversion rules
      Returns:
        the result of the comparison
      Throws:
        `XPathException` - if the first operand is not convertible to a double

    - #### compareAtomicValues

          public int compareAtomicValues​(AtomicValue a,
                                         AtomicValue b)

      Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.
      Specified by:
        `compareAtomicValues` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        <0 if a<b, 0 if a=b, >0 if a>b
      Throws:
        `java.lang.ClassCastException` - if the objects are not comparable

    - #### getCollator

          public StringCollator getCollator()

      Get the collation used by this AtomicComparer if any
      Specified by:
        `getCollator` in interface `AtomicComparer`
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          public AtomicComparer provideContext​(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Specified by:
        `provideContext` in interface `AtomicComparer`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

    - #### comparesEqual

          public boolean comparesEqual​(AtomicValue a,
                                       AtomicValue b)

      Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.
      Specified by:
        `comparesEqual` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared.
        `b` - the second object to be compared.
      Returns:
        true if the values are equal, false if not
      Throws:
        `java.lang.ClassCastException` - if the objects are not comparable

    - #### save

          public java.lang.String save()

      Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded
      Specified by:
        `save` in interface `AtomicComparer`
      Returns:
        a string representation of the AtomicComparer